<script lang="ts">
type SecurityBoxCircuitRowData = { number: number } & NdmSecurityBoxCircuit;

type SecurityBoxRuntimeRowData = { createdTime: string; diagInfo: NdmSecurityBoxDiagInfo };
</script>

<script setup lang="ts">
import { pageSnmpLogApi, type NdmSecurityBoxCircuit, type NdmSecurityBoxDiagInfo, type NdmSecurityBoxResultVO, type PageParams, type Station } from '@/apis';
import { parseErrorFeedback } from '@/utils';
import { useMutation } from '@tanstack/vue-query';
import { isCancel } from 'axios';
import dayjs from 'dayjs';
import destr from 'destr';
import { NButton, NCard, NDataTable, NModal, type DataTableColumns, type DataTableRowData, type PaginationProps } from 'naive-ui';
import { h, onBeforeUnmount, reactive, ref, toRefs, watch } from 'vue';

const props = defineProps<{
  ndmDevice: NdmSecurityBoxResultVO;
  station: Station;
}>();

const range = defineModel<[number, number]>('range');
const loading = defineModel<boolean>('loading', { default: false });

const emit = defineEmits<{
  exposeQueryFn: [queryFn: () => void];
}>();

const { ndmDevice, station } = toRefs(props);

const showDetailModal = ref(false);

const detailTableColumns: DataTableColumns<SecurityBoxCircuitRowData> = [
  { title: '电路序号', key: 'number' },
  {
    title: '状态',
    key: 'status',
    render(rowData) {
      const { status } = rowData;
      if (status === 1) {
        return '开启';
      } else if (status === 0) {
        return '关闭';
      } else {
        return '未知';
      }
    },
  },
  {
    title: '电流(A)',
    key: 'current',
    render(rowData) {
      return `${rowData.current.toFixed(3)}`;
    },
  },
  {
    title: '电压(V)',
    key: 'voltage',
    render(rowData) {
      return `${rowData.voltage.toFixed(3)}`;
    },
  },
];

const detailTableData = ref<DataTableRowData[]>([]);

const tableColumns: DataTableColumns<SecurityBoxRuntimeRowData> = [
  { title: '诊断时间', key: 'createdTime' },
  {
    title: '温度(℃)',
    key: 'temperature',
    render(rowData) {
      const { info } = rowData.diagInfo;
      const boxInfo = info?.at(0);
      if (!boxInfo) return '';
      return boxInfo.temperature;
    },
  },
  {
    title: '湿度(%)',
    key: 'humidity',
    render(rowData) {
      const { info } = rowData.diagInfo;
      const boxInfo = info?.at(0);
      if (!boxInfo) return '';
      return boxInfo.humidity;
    },
  },
  {
    title: '风扇转速(rpm)',
    key: 'fanSpeeds',
    render(rowData) {
      const { info } = rowData.diagInfo;
      const boxInfo = info?.at(0);
      if (!boxInfo) return '';
      return h('pre', {}, { default: () => boxInfo.fanSpeeds?.join('\n') ?? '' });
    },
  },
  // { title: '开关状态', key: 'switches' },
  {
    title: '电路状态',
    key: 'circuits',
    render(rowData) {
      const { info } = rowData.diagInfo;
      const boxInfo = info?.at(0);
      if (!boxInfo) return '';
      return h(
        NButton,
        {
          text: true,
          type: 'info',
          size: 'small',
          onClick: () => {
            detailTableData.value = boxInfo.circuits?.map((circuit, index) => ({ ...circuit, number: index + 1 })) ?? [];
            showDetailModal.value = true;
          },
        },
        {
          default: () => '查看',
        },
      );
    },
  },
];

const tableData = ref<DataTableRowData[]>([]);
const DEFAULT_PAGE_SIZE = 10;
const pagination = reactive<PaginationProps>({
  size: 'small',
  showSizePicker: true,
  page: 1,
  pageSize: DEFAULT_PAGE_SIZE,
  pageSizes: [5, 10, 20, 50, 80, 100],
  itemCount: 0,
  prefix: ({ itemCount }) => {
    return h('div', {}, { default: () => `共${itemCount}条` });
  },
  onUpdatePage: (page) => {
    pagination.page = page;
    getTableData();
  },
  onUpdatePageSize: (pageSize) => {
    pagination.pageSize = pageSize;
    pagination.page = 1;
    getTableData();
  },
});

const abortController = ref<AbortController>(new AbortController());

const { mutate: getTableData, isPending } = useMutation({
  mutationFn: async () => {
    if (!range.value) throw new Error('请选择时间范围');
    abortController.value?.abort();
    abortController.value = new AbortController();
    const deviceId = ndmDevice.value.id;
    if (!deviceId) throw new Error('该设备没有ID');
    const createdTime_precisest = dayjs(range.value[0]).format('YYYY-MM-DD HH:mm:ss');
    const createdTime_preciseed = dayjs(range.value[1]).format('YYYY-MM-DD HH:mm:ss');
    const restParams: Omit<PageParams<{ id: string }>, 'model' | 'extra'> = {
      current: pagination.page ?? 1,
      size: pagination.pageSize ?? DEFAULT_PAGE_SIZE,
      sort: 'id',
      order: 'descending',
    };
    const pageResult = await pageSnmpLogApi(
      {
        model: { deviceId },
        extra: { createdTime_precisest, createdTime_preciseed },
        ...restParams,
      },
      {
        stationCode: station.value.code,
        signal: abortController.value.signal,
      },
    );
    return pageResult;
  },
  onSuccess: ({ records, size, total }) => {
    pagination.pageSize = parseInt(size);
    pagination.itemCount = parseInt(total);
    tableData.value = records.map((record) => {
      const diagInfoJsonString = record.diagInfo;
      const diagInfo = destr<NdmSecurityBoxDiagInfo>(diagInfoJsonString);
      if (!diagInfo) return {};
      if (typeof diagInfo !== 'object') return {};
      return {
        createdTime: record.createdTime,
        diagInfo,
      };
    });
  },
  onError: (error) => {
    if (isCancel(error)) return;
    console.error(error);
    const errorFeedback = parseErrorFeedback(error);
    window.$message.error(errorFeedback);
  },
});

emit('exposeQueryFn', () => {
  pagination.page = 1;
  pagination.pageSize = DEFAULT_PAGE_SIZE;
  getTableData();
});

watch(isPending, (pending) => {
  loading.value = pending;
});

onBeforeUnmount(() => {
  abortController.value.abort();
});
</script>

<template>
  <NCard hoverable size="small">
    <template #header>
      <span>运行情况记录</span>
    </template>
    <template #default>
      <NDataTable size="small" :loading="isPending" :columns="tableColumns" :data="tableData" :pagination="pagination" :single-line="false" remote flex-height style="height: 500px" />
    </template>
  </NCard>
  <NModal v-model:show="showDetailModal" :preset="'card'" :auto-focus="false" :transform-origin="'center'" :content-style="{ height: '100%' }" style="min-width: 1440px; height: 100vh">
    <NDataTable size="small" :columns="detailTableColumns" :data="detailTableData" :single-line="false" :remote="false" flex-height style="height: 100%" />
  </NModal>
</template>

<style scoped lang="scss"></style>
